#!/usr/bin/env python

import libxml2dom.xmpp
import sys

sender = "sender" in sys.argv
receiver = "receiver" in sys.argv
if not (sender or receiver):
    print "Please specify sender or receiver."
    sys.exit(1)

if len(sys.argv) > 2:
    peer = sys.argv[2]
elif sender:
    peer = "paulb@localhost/receiver"

s = libxml2dom.xmpp.Session(("localhost", 5222))
d = s.connect("localhost")
print "---- 1 ----"
print d.toString()

auth = s.createAuth()
auth.mechanism = "PLAIN"
auth.setCredentials("paulb@localhost", "paulb", "jabber")
s.send(auth)
print "---- 2 ----"
d = s.receive()
print "---- 3 ----"
print d.toString()

if d.localName == "failure":
    if d.reason == "not-authorized":
        print "Not authorized: must register first!"
    s.disconnect()
    sys.exit(1)

d = s.connect("localhost")
print "---- 4 ----"
print d.toString()

iq = s.createIq()
iq.makeBind()
if sender:
    iq.bind.resource = "sender"
else:
    iq.bind.resource = "receiver"
s.send(iq)
print "---- 5 ----"
d = s.receive()
print "---- 6 ----"
print d.toString()

iq = s.createIq()
iq.makeSession("localhost")
s.send(iq)
print "---- 7 ----"
d = s.receive()
print "---- 8 ----"
print d.toString()

if sender:
    message = s.createMessage()
    message.from_ = "paulb@localhost/sender"
    message.to = peer
    message.type = "chat"
    message.body = message.createBody()
    text = message.ownerDocument.createTextNode("Hello!")
    message.body.appendChild(text)
    print "Sending..."
    print message.toString()
    s.send(message)
    d = s.receive()

if receiver:
    while 1:
        print "Listening..."
        doc = s.receive()
        print doc.toString()
        print
        print "From:", doc.from_
        print "To:", doc.to
        print "Type:", doc.type
        print
        if doc.localName == "message":
            print "Message..."
            if doc.type == "chat" and doc.body:
                print doc.body.textContent
            elif doc.event:
                print "Composing?", doc.event.composing
                print "Delivered?", doc.event.delivered
                print "Displayed?", doc.event.displayed
                print "Offline?", doc.event.offline
                print "Id:", doc.event.id
        elif doc.localName == "presence":
            print "Presence..."
            if doc.type == "subscribe":
                presence = s.createPresence()
                presence.type = "subscribed"
                presence.from_ = doc.to
                presence.to = doc.from_
                print "Sending..."
                print presence.toString()
                s.send(presence)
                d = s.receive()
        print

# vim: tabstop=4 expandtab shiftwidth=4
